testthat::context("Missing arguments")

# Check Missing NorP
testthat::test_that("Expected error messages are returned", {
  testthat::skip_on_cran()

  AbdVectorError <- "An argument NorP or Ns must be provided."
  testthat::expect_error(entropart:::Diversity.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Dqz.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hqz.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HqzBeta.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpson.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpsonD.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hurlbert.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HurlbertD.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloDiversity.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Rao.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Richness.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Shannon.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Simpson.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Tsallis.AbdVector(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.AbdVector(), AbdVectorError, ignore.case = TRUE)
  
  testthat::expect_error(entropart:::Diversity.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Dqz.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hqz.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HqzBeta.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpson.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpsonD.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hurlbert.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HurlbertD.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloDiversity.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloEntropy.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Rao.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Richness.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Shannon.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Simpson.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Tsallis.integer(), AbdVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.integer(), AbdVectorError, ignore.case = TRUE)
  
  AbdVectorExpError <- "An argument NorPexp or Nexp must be provided."
  testthat::expect_error(entropart:::HqzBeta.AbdVector(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.AbdVector(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.AbdVector(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.AbdVector(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.AbdVector(0), AbdVectorExpError, ignore.case = TRUE)
  
  testthat::expect_error(entropart:::HqzBeta.integer(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.integer(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.integer(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.integer(0), AbdVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.integer(0), AbdVectorExpError, ignore.case = TRUE)
  
  
  ProbaVectorError <- "An argument NorP or Ps must be provided."
  testthat::expect_error(entropart:::Diversity.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Dqz.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hqz.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HqzBeta.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpson.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpsonD.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hurlbert.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HurlbertD.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloDiversity.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloEntropy.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Rao.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Richness.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Shannon.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Simpson.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Tsallis.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.ProbaVector(), ProbaVectorError, ignore.case = TRUE)
  
  ProbaVectorExpError <- "An argument NorPexp or Pexp must be provided."
  testthat::expect_error(entropart:::HqzBeta.ProbaVector(0), ProbaVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.ProbaVector(0), ProbaVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.ProbaVector(0), ProbaVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.ProbaVector(0), ProbaVectorExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.ProbaVector(0), ProbaVectorExpError, ignore.case = TRUE)
  
  
  numericError <- "An argument NorP or Ps or Ns must be provided."
  testthat::expect_error(entropart:::Diversity.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Dqz.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hqz.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HqzBeta.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpson.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::GenSimpsonD.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Hurlbert.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::HurlbertD.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloDiversity.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloEntropy.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Rao.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Richness.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Shannon.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Simpson.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::Tsallis.numeric(), numericError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.numeric(), numericError, ignore.case = TRUE)
  
  numericExpError <- "An argument NorPexp or Pexp or Nexp must be provided."
  testthat::expect_error(entropart:::HqzBeta.numeric(0), numericExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::PhyloBetaEntropy.numeric(0), numericExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::ShannonBeta.numeric(0), numericExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::SimpsonBeta.numeric(0), numericExpError, ignore.case = TRUE)
  testthat::expect_error(entropart:::TsallisBeta.numeric(0), numericExpError, ignore.case = TRUE)
  
})
